#ifndef __PIXEL_C
#define __PIXEL_C

#include <findpix.h>

/* Small c library, by Chris Dannemiller (dannemiller@hotmail.com)
   http://www.geocities.com/SiliconValley/Vista/1143

   Synopsis:
      pixel(x,y,c)

   Description:
      This fuction draws a pixel at the (x,y) cordidate with the the
      specifed drawing mode

   Example:
      pixel(0,0,PT_ON)
      pixel(5,5,PT_CHG)

   Notes:
      o See ti86.h for desciption of the PT_* macros
      o This funtion could be faster!

*/

pixel(x,y,c) char x, y, c; {
#asm
        ld      hl,2
        add     hl,sp
        ld      a,(hl)

        inc     hl
        inc     hl
        ld      c,(hl)

        inc     hl
        inc     hl
        ld      b,(hl)

        ; a = Color
        ; e = x
        ; d = y
_drawpix:
        and     a
        jp      z,_delpix
        dec     a
        jp      z,_putpix
        dec     a 
        jp      z,_chgpix
        jp      _pixend
_putpix:
        call    FindPixel
        or      (HL)
        ld      (HL),A
        ret
_delpix:
        call    FindPixel
        cpl
        and     (HL)
        ld      (HL),a
        ret
_chgpix:
        call    FindPixel
        xor     (HL)
        ld      (HL),A
        ret
_pixend:
#endasm
}
#endif
