/*
|---------------------------------------------|
| lights out example for the ti-83cc          |
| Ported from the 86 by Jeremy Scoggins       |
|---------------------------------------------|
*/

/* Program Name */
#name "Lights Out"

#include <ti83.h>
#include <findpix.h>
#include <pixel.c>
#include <line.c>
#include <box.c>
#include <delay.c>
#include <fastcopy.h>

char board[25];
char xpos, ypos;
int moves;
int minmoves;
char level;

#define xsize 13
#define ysize 12

main() {
 int inloop;
 char key, cmate, x, z;

 /* Earse the contents of the screen */
 indicatoroff;
 clrlcd;

 /* Setup a intro Screen */

 setxy(3,1);
 puts("Lights-Out");
 setxy(2,2);
 puts("83CC Example");
 setxy(3,4);
 puts("By: Chris");
 setxy(2,5);
 puts("Dannemiller");

 level = 1;

 getkey();

 clrlcd;


 /* Earse the boards contents */
 cleanboard();

 /* Setup a trial level */

 /* User is at defualt location */
 xpos = 0;
 ypos = 0;
 
 displaygame();
 vdance();

 invert(2,2);
 invert(2,1);
 invert(2,3);
 invert(1,2);
 invert(3,2);
 getkey();
 invert(2,2);
 invert(2,1);
 invert(2,3);
 invert(1,2);
 invert(3,2);

 loadlevel();

 moves = 0;
 pushbutton();

 inloop = 1;
 while(inloop == 1)
   {
   key = getkey();
   if(key == kClear)
     inloop = 0;
   if(key == kUp && ypos > 0)
     {
     relasebutton();
     ypos--;
     pushbutton();
     }
   if(key == kDown && ypos < 4)
     {
     relasebutton();
     ypos++;
     pushbutton();
     }
   if(key == kRight && xpos < 4)
     {
     relasebutton();
     xpos++;
     pushbutton();
     }
   if(key == kLeft && xpos > 0)
     {
     relasebutton();
     xpos--;
     pushbutton();
     }
   if(key == kEnter)
     {
     invert(xpos,ypos);
     invert(xpos+1,ypos);
     invert(xpos-1,ypos);
     invert(xpos,ypos+1);
     invert(xpos,ypos-1);
     moves++;
     /* Check for win */

     cmate=0;

     for(x = 0; x < 25; x++)
       cmate = cmate + board[x];

     if(cmate==0)
       {
       inloop=0;
       relasebutton();
       moves -= minmoves;
       if(moves > 10)
         {
         invert(0,0);
         invert(1,1);
         invert(2,2);
         invert(3,3);
         invert(4,4);
         invert(4,0);
         invert(3,1);
         invert(1,3);
         invert(0,4);
         getkey();
         }
       else if(moves != 0)
         {
         char ys,xs,p;
         ys = 0;
         xs = 0;
         for(p=0; p<moves; p++)
           {
           invert(xs,ys);
           xs++;
           if(xs > 4) {
             xs = 0;
             ys++;
             }
           }
         getkey();
         }
       else
         vdance();
       }
     }
   }

 clrlcd;
 clrscrn;
 setxy(0,0);
 }

loadlevel() {
 char x,y,z;
 char *lptr;
 /* Rotine to show the level */
 x = level-1;
 y = 0;
 if(level > 25)
   {
   invert(4,4);
   x -= 25;
   }
 while(x > 5)
   {
   x-=5;
   y++;
   }
 for(z = 0; z < 5; z++)
   {
   invert(x,y);
   delay(50);
   invert(x,y);
   delay(30);
   }

 if(level > 25)
   invert(4,4);

 if(level == 1)
   {
   board[10] = 1;
   board[12] = 1;
   board[14] = 1;
   minmoves = 6;
   }
 drawboard();
 }

/* Show the victory Dance or otherwize called the startup rotine */

vdance() {
  int x;
  for(x = 0; x < 5; x++)
    {
    invert(0,x);
    delay(25);
    invert(0,x);
    }
  for(x = 1; x < 5; x++)
    {
    invert(x,4);
    delay(25);
    invert(x,4);
    }
  for(x = 3; x >= 0; x--)
    {
    invert(4,x);
    delay(25);
    invert(4,x);
    }
  for(x = 3; x > 0; x--)
    {
    invert(x,0);
    delay(25);
    invert(x,0);
    }
  for(x = 1; x < 4; x++)
    {
    invert(1,x);
    delay(25);
    invert(1,x);
    }

  invert(2,3);
  delay(25);
  invert(2,3);
  invert(3,3);
  delay(25);
  invert(3,3);
  invert(3,2);
  delay(25);
  invert(3,2);
  invert(3,1);
  delay(25);
  invert(3,1);
  invert(2,1);
  delay(25);
  invert(2,1);
  invert(2,2);
  delay(25);
  invert(2,2);
}

drawboard() {
  char z;
  char x,y;
  for(x = 0; x < 5; x++)
    for(y = 0; y < 5; y++)
      if(getboard(x,y) == 1)
        for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
          line(x*xsize+4,z,x*xsize+xsize-4,z,PT_ON);
  FastCopy();
  }
  

invert(x,y) char x, y; {
  int z;
  if(x > 4 || x < 0 ||
     y > 4 || y < 0)
    return;
  if(getboard(x,y) == 1)
  {
    setboard(x,y, 0);
    for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
      line(x*xsize+4,z,x*xsize+xsize-4,z,PT_OFF);
  } else {
    setboard(x,y, 1);
    for(z = y*ysize+4; z < y*ysize+ysize-3; z++)
      line(x*xsize+4,z,x*xsize+xsize-4,z,PT_ON);
  }
 FastCopy();
}

setboard(x,y,v) char x, y, v; {
  board[y*5+x] = v;
  }

getboard(x,y) char x,y; {
  return board[y*5+x];
}

cleanboard() {
  int x,y;
  for(x = 0; x < 25; x++)
    board[x] = 0;
  }

pushbutton() {
  box(xpos*xsize+1, ypos*ysize+1, xpos*xsize+xsize-1, ypos*ysize+ysize-1,PT_OFF);
  line(xpos*xsize+1,ypos*ysize,xpos*xsize+1,ypos*ysize+ysize,PT_ON);
  line(xpos*xsize,ypos*ysize+1,xpos*xsize+xsize,ypos*ysize+1,PT_ON);
  FastCopy();
  }

relasebutton() {
  box(xpos*xsize+1, ypos*ysize+1, xpos*xsize+xsize-1, ypos*ysize+ysize-1,PT_OFF);
  line(xpos*xsize,ypos*ysize+ysize-1,xpos*xsize+xsize,ypos*ysize+ysize-1,PT_ON);
  line(xpos*xsize+xsize-1,ypos*ysize,xpos*xsize+xsize-1,ypos*ysize+ysize,PT_ON);
  FastCopy();
  }

displaygameboard()
 {
 /* Draw all 3d boxs */
 char x, y, z;

 for(x = 0; x < 5; x++)
   for(y = 0; y < 5; y++)
     {
     box(x*xsize,y*ysize,x*xsize+xsize,y*ysize+ysize,PT_ON);
     box(x*xsize+2,y*ysize+2,x*xsize+xsize-2,y*ysize+ysize-2,PT_ON);
     line(x*xsize,y*ysize+ysize-1,x*xsize+xsize,y*ysize+ysize-1,PT_ON);
     line(x*xsize+xsize-1,y*ysize,x*xsize+xsize-1,y*ysize+ysize,PT_ON);
     }
 FastCopy();
 }
