/* Test funality of CTYPE.C for accuracy */

#include <ti.h>
#include <ctype.c>
#include <strcpy.c>

int c;

/* print out allowed charters for type */
#define prclass(expr) \
{\
    puts(#expr);\
    puts(": ");\
    for(c = 0x00; c <= 0xff; c++)\
        if(expr(c))\
            putc(c);\
    nl;\
}

main()
{
    char *s;

    prclass(isupper);
    prclass(islower);
    prclass(isdigit);
    prclass(isalpha);

    for(s = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; *s; ++s)
        if(!isupper(*s))
            puts("isupper test failed");
    for(s = "abcdefghijklmnopqrstuvwxyz"; *s; ++s)
        if(!islower(*s))
            puts("islower test failed");
    for(s = "0123456789"; *s; ++s)
        if(!isdigit(*s))
            puts("isdigit test failed");   
    for(s = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"; *s; ++s)
        if(!isalpha(*s))
            puts("isalpha test failed");
    for(s = "abcdefghijklmnopqrstuvwxyz"; *s; ++s)
        if(!isupper(toupper(*s)))
            puts("toupper test failed");
    for(s = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; *s; ++s)
        if(!islower(tolower(*s)))
            puts("tolower test failed");
}
