/*	File main.c: 2.7 (84/11/28,10:14:56) */
/*% cc -O -c %
 *
 */

#include <stdio.h>
#include "defs.h"
#include "data.h"

char szProgramName[128] = "TI-83C Program";

int main (int argc, int *argv)
{
	char	*p,*bp;
	int smacptr;
	macptr = 0;
	ctext = 0;
	argc--; argv++;
	errs = 0;
	aflag = 1;
#ifdef	FRAME_I
	frameix = 0;
        frameiy = 0;
#endif
	while (p = *argv++)
		if (*p == '-') while (*++p)
			switch(*p) {
				case 't': case 'T':
					ctext = 1;
					break;
				case 's': case 'S':
					sflag = 1;
					break;
				case 'c': case 'C':
					cflag = 1;
					break;
				case 'a': case 'A':
					aflag = 0;
					break;
				case 'd': case 'D':
					bp = ++p;
					if (!*p) usage();
					while (*p && *p != '=') p++;
					if (*p == '=') *p = '\t';
					while (*p) p++;
					p--;
					defmac(bp);
					break;
#ifdef	FRAME_I
				case 'x': case 'X':
					frameix = 1;
					break;
                                case 'y': case 'Y':
                                        frameiy = 1;
                                        break;
#endif
				case 'm': case 'M':
					bp = ++p;
					if (!*p) usage();
					if(!stricmp(bp, "TI86"))
						timode = TI_86;
					if(!stricmp(bp, "TI83"))
						timode = TI_83;
					while (*p) p++;
					p--;
					break;
				default:
					usage();
			}
			else break;

        if(frameix && frameiy)
        {
            printf("Cannot frame IX AND IY AT THE SAME TIME\n");
            return 10;
        }
	smacptr = macptr;
	if (!p)
		usage();
	if (timode == TI_NONE)
	{
		fputs("User must specify TI-Compile mode (option -m)\n\n", stderr);
		usage();
	}
	while (p) {
		fputs("Small C (v.Beta 3) - TI-83/TI-86 modification by Chris Dannemiller\n",stderr);
		errfile = 0;
		if (tolower(xtypeof(p)) == 'c' || tolower(xtypeof(p)) == 'i') {
			glbptr = STARTGLB;
			locptr = STARTLOC;
			wsptr = ws;
			inclsp =
			iflevel =
			skiplevel =
			swstp =
			litptr =
			stkp =
			errcnt =
			ncmp =
			lastst =
			quote[1] =
			0;
			macptr = smacptr;
			input2 = NULL;
			quote[0] = '"';
			cmode = 1;
			glbflag = 1;
			nxtlab = 0;
			litlab = getlabel ();
			defmac("end\tmemory");
			addglb("memory", ARRAY, CCHAR, 0, EXTERN);
			addglb("stack", ARRAY, CCHAR, 0, EXTERN);
			rglbptr = glbptr;
			addglb ("etext", ARRAY, CCHAR, 0, EXTERN);
			addglb ("edata", ARRAY, CCHAR, 0, EXTERN);
			defmac("short\tint");
			initmac();
			/*
			 *	compiler body
			 */
			if (!openin (p))
				return (1);
			if (!openout ())
				return (1);
			header (p);
			gtext ();
			parse ();
			fclose (input);
			gdata ();
			dumplits ();
			gbss ();
			dumpglbs ();
			errorsummary ();
			trailer ();
			fclose (output);
			errs = errs || errfile;
		} else {
			fputs("Don't understand file ", stderr);
			fputs(p, stderr);
			fputs("\n", stderr);
			errs = 1;
		}
		p = *argv++;
	}
	exit(errs != 0);
}

FEvers()
{
	outstr("\tFront End (2.7,84/11/28)");
}

usage()
{
	fputs("usage: 8xcc [-tcsa] [-dSYM[=VALUE]] -m[TI83 or TI86] files\n", stderr);
	exit(1);
}

void doname(void)
{
	int i = 0;
	blanks();
	if(ch() != '"')
	{
		error("Invalid program description");
		return;
	}
	gch();
	while(ch() != '"' && ch()) {
		szProgramName[i++] = gch();
		if(i > 79)
		{
			error("Program description to long");
			return;
		}
	}
	gch();
	szProgramName[i] = 0;
}

/*
 *	process all input text
 *
 *	at this level, only static declarations, defines, includes,
 *	and function definitions are legal.
 *
 */
parse ()
{
	while (!feof (input)) {
		if (amatch ("extern", 6))
			dodcls(EXTERN);
		else if (amatch ("static",6))
			dodcls(STATIC);
		else if (dodcls(PUBLIC)) ;
		else if (match ("#asm"))
			doasm ();
		else if (match ("#include"))
			doinclude ();
		else if (match ("#define"))
			dodefine();
		else if (match ("#undef"))
			doundef();
		else if (match ("#name"))
			doname();
		else if (match ("#line") | match("#"))
			kill();
		else
			newfunc ();
		blanks ();
	}
}

/*
 *		parse top level declarations
	*/

dodcls(stclass)
int stclass; {
	blanks();
	if (amatch("char", 4))
		declglb(CCHAR, stclass);
	else if (amatch("int", 3))
		declglb(CINT, stclass);
	else if (stclass == PUBLIC)
		return(0);
	else
		declglb(CINT, stclass);
	ns ();
	return(1);
}


/*
 *	dump the literal pool
 */
dumplits ()
{
	int	j, k;

	if (litptr == 0)
		return;
	printlabel (litlab);
	col ();
	k = 0;
	while (k < litptr) {
		defbyte ();
		j = 8;
		while (j--) {
			outdec (litq[k++] & 127);
			if ((j == 0) | (k >= litptr)) {
				nl ();
				break;
			}
			outbyte (',');
		}
	}
}

/*
 *	dump all static variables
 */
dumpglbs ()
{
	int	j;

	if (!glbflag)
		return;
	cptr = rglbptr;
	while (cptr < glbptr) {
		if (cptr[IDENT] != FUNCTION) {
			ppubext(cptr);
			if (cptr[STORAGE] != EXTERN) {
				prefix ();
				outstr (cptr);
				col ();
				defstorage ();
				j = glint(cptr);
				if ((cptr[TYPE] == CINT) ||
				    (cptr[IDENT] == POINTER))
					j = j * intsize();
				onum (j);
				nl ();
			}
		} else {
			fpubext(cptr);
		}
		cptr = cptr + SYMSIZ;
	}
}

/*
 *	report errors
 */
errorsummary ()
{
	if (ncmp)
		error ("missing closing bracket");
	nl ();
	comment ();
	outdec (errcnt);
	if (errcnt) errfile = YES;
	outstr (" error(s) in compilation");
	nl ();
	comment();
	ot("literal pool:");
	outdec(litptr);
	nl();
	comment();
	ot("global pool:");
	outdec(glbptr-rglbptr);
	nl();
	comment();
	ot("Macro pool:");
	outdec(macptr);
	nl();
	if (errcnt)
		pl("Error(s)\n");
}

xtypeof(s)
char	*s; {
	s += strlen(s) - 2;
	if (*s == '.')
		return(*(s+1));
	return(' ');
}
